#include <stdlib.h>
#include <stdio.h>
#include <sys/msg.h>
#include <time.h>
#include <errno.h>

struct msgbuf {
  long mtype;
  int pid;
  char text[128];
};

int kolejka;

void koniec() {
  msgctl(kolejka, IPC_RMID, 0);
  exit(EXIT_SUCCESS);
}

int main() {
  key_t klucz = ftok("./klient", 12321);
  struct msgbuf komunikat;
  time_t c;
  struct tm*czas;

  kolejka = msgget(klucz, 0);

  if (kolejka == -1) {
    fprintf(stderr, "Nie mozna otworzyc kolejki\n");
    exit(EXIT_FAILURE);
  }

  komunikat.pid = getpid();

  for (;;) {
    komunikat.mtype = (rand()%2) + 1;
    c = time(0);
    czas = localtime(&c);
    sprintf(komunikat.text, "%d:%d:%d", czas->tm_hour, czas->tm_min, czas->tm_sec);
    msgsnd(kolejka, &komunikat, strlen(komunikat.text)+5, 0);
    if (errno == EIDRM || errno == EFAULT || errno == EINVAL) {
      printf("Kolejka zamknieta\n");
      koniec();
    }
    sleep((rand()%3)+1);
  }
}
