#include <stdlib.h>
#include <stdio.h>
#include <sys/msg.h>
#include <signal.h>

struct msgbuf {
  long mtype;
  int pid;
  char text[128];
};

int kolejka;

void koniec() {
  msgctl(kolejka, IPC_RMID, 0);
  exit(EXIT_SUCCESS);
}

int main(int argc, char**argv) {
  key_t klucz = ftok("klient", 12321);
  int czas = -1;
  struct msgbuf komunikat;

  if (argc<2) {
    printf("Parametry: czas [-p]\n");
    exit(EXIT_FAILURE);
  }

  sscanf(argv[1], "%d", &czas);
  if (czas < 0) {
    fprintf(stderr, "Ilosc sekund musi byc >= 0\n");
    exit(EXIT_FAILURE);
  }

  kolejka = msgget(klucz, IPC_CREAT | IPC_EXCL | 0666);

  if (kolejka == -1) {
    fprintf(stderr, "Nie mozna utworzyc kolejki\n");
    exit(EXIT_FAILURE);
  }

  signal(SIGINT, koniec);

  if (argc<3)
    for (;;) {
      if (msgrcv(kolejka, &komunikat, 132, 0, IPC_NOWAIT) != -1) {
	printf("Pid: %d  Czas: %s\n", komunikat.pid, komunikat.text);
	sleep(czas);
      }
    }

  for (;;) {
    if (msgrcv(kolejka, &komunikat, 132, 2, IPC_NOWAIT) != -1) {
      printf("Pid: %d  Czas: %s\n", komunikat.pid, komunikat.text);
      sleep(czas);
      continue;
    } else if (msgrcv(kolejka, &komunikat, 132, 0, IPC_NOWAIT) != -1) {
      printf("Pid: %d  Czas: %s\n", komunikat.pid, komunikat.text);
      sleep(czas);
    }
  }
}
