#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/stat.h>

struct kolejka {
	short pocz;
	short kon;
	short ilosc;
	char dane[5][128];
};

static int shmid, sem;
static struct kolejka* q;

static void P() {
	struct sembuf sb;
 
	sb.sem_num=0;
	sb.sem_op=-1;
	sb.sem_flg=SEM_UNDO;        

	if(semop(sem,&sb,1)==-1)
		perror(0);
}

static void V() {
	struct sembuf sb;
 
	sb.sem_num=0;
	sb.sem_op=1;
	sb.sem_flg=SEM_UNDO;
 
	if(semop(sem,&sb,1)==-1)
		perror(0);
}

void inicjuj_kolejke() {
	short do_memset = 0;

	if((shmid=shmget(ftok("madqba_queue",0),sizeof(struct kolejka),0))==-1)
		if((shmid=shmget(ftok("madqba_queue",0),sizeof(struct kolejka),S_IRWXU|IPC_CREAT))==-1)
			perror(0);
		else
			do_memset = 1;
			
	if((q=(struct kolejka*)shmat(shmid,(unsigned char*)0,0))==(void*)-1)
		perror(0);
		
	if (do_memset)
		memset(q, 0, sizeof(struct kolejka));

	if((sem=semget(ftok("madqba_semaphore",0),0,0))==-1) {
	  	if((sem=semget(ftok("madqba_semaphore",0),1,S_IRWXU|IPC_CREAT))==-1)
			perror(0);
  		if(semctl(sem,0,SETVAL,1)==-1)
			perror(0);
	}
}

int dodaj_do_kolejki(char* komunikat) {
	int retval;
	
	P();
	if (q->ilosc == 5)
		retval = -1;
	else {
		q->kon = (q->kon + 1) % 5;
		if (q->ilosc == 0)
			q->pocz = q->kon;
		strcpy(q->dane[q->kon], komunikat);
		q->ilosc++;
		retval = 0;
	}
	V();
	return retval;
}

int pobierz_z_kolejki(char* wsk) {
	int retval;

	P();
	if (q->ilosc==0)
		retval = -1;
	else {
		strcpy(wsk, q->dane[q->pocz]);
		q->ilosc--;
		q->pocz = (q->pocz + 1) % 5;
		retval = 0;
	}
	V();
	return retval;
}

void zniszcz_kolejke() {
	shmctl(shmid, IPC_RMID, 0);
	semctl(sem, IPC_RMID, 0);
}
